#!/usr/bin/perl -w

use Data::Dumper;
use strict;
use Fork;


sub b($) {
    return "<$_[0]>";
}

sub test_fork($) {
    sleep $_->[2];
    return [$_->[0], b $_->[1]];
}

sub test_fork_2($) {
    sleep shift;
    return (undef);
}

sub main {
    # Change this to increase/decrease execution time
    my $max_forks = 6;
    my $timeout = 10;
    my $data = [
		# ID, data, ...
		[1 ,"Item 1", 1],
		[2 ,"Item 6", 6],
		[3 ,"Item 2", 2],
		[4 ,"Item 5", 3],
		[5 ,"Item 3", 5],
 		[6 ,"Item 4", 4],
		];

    my $data2 = [1, 2, 3, 4, 5, 6];

    # Returns undef
    print Dumper fork_it {
	fct => \&test_fork_2,
	args => $data2,
	max_children => $max_forks,
	timeout => $timeout,
    };

    print Dumper fork_it {
	fct => \&test_fork,
	args => $data,
	max_children => $max_forks,
	timeout => $timeout,
	};
    # safer method
    my $values = fork_it {
	fct => \&test_fork,
	args => $data,
	max_children => $max_forks,
	timeout => $timeout,
	};
    my $sorted_values = [ sort { $b->[0] cmp $a->[0] } (@$values) ];
    print Dumper $sorted_values;
}


main;
